% *****************************************************************
% authors:  Fei Chen, Gene Cheung, Xue Zhang                     **
% paper:    Manifold Graph Signal Restoration using Gradient     **
%           Graph Laplacian Regularizer, submitted to TSP, 2022  **
% date:     12/3/2022                                            **
% modified: 12/3/2022                                            **
% *****************************************************************

clear all;
close all;

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
x = double(imread('lena_patch.png'))./255;
[sx,sy]=size(x);

rand('seed', 0);
mask = rand(size(x))<=0.1; 
y = x.*mask;   
[w, p] = Img2adj_mat(y);
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
par.mu = 0.1;
par.nsig=50;
par.IterNum=2;

tic
[z, alpha1,alpha2] = GGLR(p,y(:),w,mask(:),par);
toc

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
disp(['GGLR:' num2str(psnr(x(:),y(:))) 'dB  --> ' num2str(psnr(x(:),z(:))) 'dB.']);
subplot(131)
imshow(reshape(x,sx,sy));
title('Original Patch');
subplot(132)
imshow(reshape(y,sx,sy));
title(['Corrupted:' num2str(psnr(x(:),y(:))) 'dB']);
subplot(133)
imshow(reshape(z,sx,sy));
title(['GGLR:' num2str(psnr(x(:),z(:))) 'dB']);
