% *****************************************************************
% authors:  Fei Chen, Gene Cheung, Xue Zhang                     **
% paper:    Manifold Graph Signal Restoration using Gradient     **
%           Graph Laplacian Regularizer, submitted to TSP, 2022  **
% date:     12/3/2022                                            **
% modified: 12/3/2022                                            **
% *****************************************************************

function [ w,p] = Img2adj_mat(x)
[sx, sy]=size(x);
N=sx*sy;
p=zeros(2,N);
w=sparse(N,N);
for i=1:sx
    for j=1:sy
        if j+1<=sy
            w((i-1)*sx+j,(i-1)*sx+j+1)=1;
        end
        if j-1>=1
            w((i-1)*sx+j,(i-1)*sx+j-1)=1;
        end
        if i+1<=sx
            w((i)*sx+j,(i-1)*sx+j)=1;
        end
        if i-1>=1
            w((i-2)*sx+j,(i-1)*sx+j)=1;
        end
        p(:,(i-1)*sx+j)=[j,i]';
    end
end
end

